#include "usart.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct node_t {
	struct node_t *next;
};

typedef struct person {
		char *name;
		int age;
		//struct person *next;
	struct node_t node;
}PERSON, *PPERSON;
typedef struct list {
		char *name;
		struct node_t head;
}LIST, *PLIST;
void ListInit(PLIST pList, char *name)
{
	pList->name = name;
	pList->head.next = NULL;
}


void AddItemToList(PLIST pList, struct node_t *new_node)
{
	struct node_t *pLast = &(pList->head);
	
	while(pLast->next)
	{
		pLast = pLast->next;
	}
	
	pLast->next = new_node;
	new_node->next = NULL;
	
}
void AddItemAfter(struct node_t *node, struct node_t *new_node)
{
	new_node->next = node->next;
	node->next = new_node;
}

//ַؽڵָ
struct node_t * NameToNode(PLIST pList, char * name)
{
	struct node_t * p = &(pList->head);
	
	while(p != NULL)
	{
		p = p->next;
		if(strcmp(((struct person *)((unsigned int *)p - (unsigned int )&((struct person *)0)->node))->name, name) == 0)
			return p;
	}
	if(p == NULL)
	{
		printf("can not find the person \r\n");
		return NULL;
	}	
	return NULL;
}

//ɾڵ
int DeleteItemFromList(PLIST pList, char * delname)
{
	struct node_t * p = &(pList->head);
	struct node_t * pre = NULL;
	struct node_t * delp = NameToNode(pList, delname);
	
	if(delp == NULL)
		return -1;
	
//	printf("\r\n%s  %s  age  is : %d \r\n\r\n", pList->name, delp->name, delp->age);
	
	if(p == NULL)
		return -1;
	
	while(p != delp)
	{
			pre = p;
			p = p->next;
	}
	pre->next = p->next;
	
	return 0;
}


void DelItemFromList(struct list *pList, struct node_t *node)
{
	struct node_t *pre = &pList->head;
	
	/* ??person */
	while (pre != NULL && pre->next != node)
	{
		pre = pre->next;
	}
	
	/* ??? */
	if (pre == NULL)
		return;
	else
		pre->next = node->next;
}

//ַ person ṹָ
struct person *perToNode(PLIST pList, char * name)
{
	struct node_t * p = &(pList->head);
	struct person * pre = NULL;
	
	while(p != NULL)
	{
		p = p->next;
		pre = ((struct person *)((unsigned int *)p - (unsigned int)&((struct person *)0)->node));
		if(strcmp(pre->name, name) == 0)
			return pre;
	}
	if(p == NULL)
	{
		printf("can not find the person \r\n");
		return NULL;
	}	
	return NULL;
}

//
int SortList(PLIST pList)
{
	struct node_t * pre = &(pList->head);
	struct node_t * head = pre->next;
	struct node_t * next;
	struct node_t * head_font = pre;
	struct node_t * next_font = NULL;
	struct node_t * temp;
	
	if(pre == NULL)
		return -1;
	
	while(head)
	{
		
		next_font = head;
		next = head->next;
		while(next)
		{
			if((perToNode(  pList, ((struct person *)((unsigned int *)head - (unsigned int )&((struct person *)0)->node))->name    )->age) > (perToNode(pList, ((struct person *)((unsigned int *)next - (unsigned int )&((struct person *)0)->node))->name)->age))
			{

				DeleteItemFromList(pList, (perToNode(  pList, ((struct person *)((unsigned int *)head - (unsigned int )&((struct person *)0)->node))->name  )->name));
				DeleteItemFromList(pList, (perToNode(  pList, ((struct person *)((unsigned int *)next - (unsigned int )&((struct person *)0)->node))->name  )->name));
				
				AddItemAfter(head_font, next);
				
				if(head == next_font)
					AddItemAfter(next, head);
				else
					AddItemAfter(next_font, head);
				
				temp = head;
				head = next;
				next = temp;				
			}
			next_font = next;
			next = next->next;
		}
		head_font = head;
		head = head->next;
	}
	
	return 0;
}

void printfListAll(PLIST pList)
{
	struct node_t *pnode = (pList->head).next;
	struct person *p;
	int i = 0;
	while(pnode != NULL)
	{
		p = perToNode(pList, ((struct person *)((unsigned int *)pnode - (unsigned int)&((struct person *)0)->node))->name);
		printf("%s  %d  %s age is : %d\r\n", pList->name, i++, p->name, p->age);

		pnode = pnode->next;
	}
	printf("----------------------------------------------\r\n");
}

int main(int argc, char **arg)
{
		LIST a_list;
		int i = 0;
		PERSON p[] = {
									{"p1", 20, {NULL}},
									{"p2", 12, {NULL}},
									{"p3", 39, {NULL}},
									{"p4", 56, {NULL}},				
									{"p5", 34, {NULL}},
									{"p6", 43, {NULL}},		
									{"p7", 12, {NULL}},
									{"p8", 10, {NULL}},		
									{"P9", 67, {NULL}},
									{"pa", 23, {NULL}}
		};
    
    HAL_Init();
    
    MX_USART1_UART_Init();
    
		ListInit(&a_list, "A_Class");
		
		for(i = 0; i < sizeof(p)/sizeof(p[0]); i++)
		{
			AddItemToList(&a_list, &p[i].node);
		}
		
		printf("All person : \r\n");
		printfListAll(&a_list);
    
		DeleteItemFromList(&a_list, "p4");
		printf("Dele person p4 \r\n");
		printfListAll(&a_list);
		
		DeleteItemFromList(&a_list, "p1");
		printf("Dele person p1 \r\n");
		printfListAll(&a_list);
		
		SortList(&a_list);
   	printf("sort list, all person:\r\n");
		printfListAll(&a_list);
    while(1)
    {
    }
}

void Error_Handler(void)
{
    printf("Error\r\n");
    while(1)
    {
    }
}
